package refactored;

import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

public class SalesData {

	ArrayList<Double> dailySales = new ArrayList<>();
	ArrayList<Double> dailyTaxes = new ArrayList<>();
	int numDaysOpen;
	double salesTotal;
	double taxTotal;
	double salesAvg;
	double taxAvg;
	String companyName;
	
	public static void main(String[] args) {
	}
	
	public void readData(String fileName, String company) throws FileNotFoundException {
		File inFile = new File(fileName);
		Scanner input = new Scanner( inFile );
		int numDays = 0;
		if(company.equals("Liard Springs")) {
			companyName = input.nextLine();
			input.nextLine();
			input.nextLine();
			while(input.hasNextLine()) {
				String day = input.nextLine();
				String[] tokens = day.split("\t");
				if(tokens.length==2) {
					numDaysOpen++;
					double salesAndTax = Double.parseDouble(tokens[1]);
					double sales = salesAndTax/1.07;
					sales = Math.round(sales*100.0)/100.0;
					double tax = sales*0.07;
					tax = Math.round(tax*100.0)/100.0;
					double discrepancy = sales+tax-salesAndTax;
					tax -= discrepancy;
					dailySales.add(sales);
					dailyTaxes.add(tax);
				}
			}
		}
		if(company.equals("Beneath & Before")) {
			companyName = input.nextLine();
			input.nextLine();
			while(input.hasNextLine()) {
				String day = input.nextLine();
				String[] tokens = day.split("\t");
				if(tokens.length==2) {
					numDaysOpen++;
					dailySales.add(Double.parseDouble(tokens[0]));
					dailyTaxes.add(Double.parseDouble(tokens[1]));
				}
			}
		}
		
		input.close();
		computeSalesAverage();
		computeTaxAverage();
	}
	
	private void computeSalesAverage() {
		double sum = 0.0;
		for(double sales : dailySales) {
			sum += sales;
		}
		salesTotal = sum;
		salesAvg = sum/numDaysOpen;
	}

	private void computeTaxAverage() {
		double sum = 0.0;
		for(double sales : dailyTaxes) {
			sum += sales;
		}
		taxTotal = sum;
		taxAvg = sum/numDaysOpen;
	}
	
	private String shortHeader() {
		StringBuilder rpt = new StringBuilder();
		rpt.append("Company: " + companyName + "\n");
		return rpt.toString();
	}

	private String fancyHeader() {
		String rpt;
		
		rpt = "*********************************\n";
		rpt += "* Company: " + companyName + "\n";
		rpt += "*********************************\n";
		return rpt;
		
	}
	
	public String getReport(String type, String hType) {
		StringBuilder rpt = new StringBuilder();
		if(type.equals("short")) {
			rpt = new StringBuilder();
			if(hType.equals("brief"))
				rpt.append(shortHeader());
			else if(hType.equals("fancy"))
				rpt.append(fancyHeader());
			rpt.append("Day Open: " + numDaysOpen + "\n");
			String line = String.format("Total Sales: $%,.2f\n", salesTotal);
			rpt.append(line);
			line = String.format("Average Sales: $%,.2f\n", salesAvg);
			rpt.append(line);
			
		}
		else if(type.equals("long")) {
			if(hType.equals("brief"))
				rpt.append(shortHeader());
			else if(hType.equals("fancy"))
				rpt.append(fancyHeader());
			rpt.append("Day Open: " + numDaysOpen + "\n");
			String line = String.format("Total Sales: $%,.2f\n", salesTotal);
			rpt.append(line);
			line = String.format("Average Sales: $%,.2f\n", salesAvg);
			rpt.append(line);
			line = String.format("Total Taxes: $%,.2f\n", taxTotal);
			rpt.append(line);
			line = String.format("Average Taxes: $%,.2f\n", taxAvg);
			rpt.append(line);
			rpt.append("\nSales:\n");
			int i=1;
			for(double sales : dailySales) {
				rpt.append(String.format("$%,.2f ", sales));
				if(i%5==0) rpt.append("\n");
				i++;
			}
		}
		else if(type.equals("long+taxes")) {
			if(hType.equals("brief"))
				rpt.append(shortHeader());
			else if(hType.equals("fancy"))
				rpt.append(fancyHeader());
			rpt.append("Day Open: " + numDaysOpen + "\n");
			String line = String.format("Total Sales: $%,.2f\n", salesTotal);
			rpt.append(line);
			line = String.format("Average Sales: $%,.2f\n", salesAvg);
			rpt.append(line);
			line = String.format("Total Taxes: $%,.2f\n", taxTotal);
			rpt.append(line);
			line = String.format("Average Taxes: $%,.2f\n", taxAvg);
			rpt.append(line);
			rpt.append("\nSales:\n");
			int i=1;
			for(double sales : dailySales) {
				rpt.append(String.format("$%,.2f ", sales));
				if(i%5==0) rpt.append("\n");
				i++;
			}
			rpt.append("\n\nTaxes:\n");
			i=1;
			for(double tax : dailyTaxes) {
				rpt.append(String.format("$%,.2f ", tax));
				if(i%5==0) rpt.append("\n");
				i++;
			}
		}		
		return rpt.toString();
	}

}
